From 7449810386821229b10c3dc0bf71bff3e143efef Mon Sep 17 00:00:00 2001
From: Mark Reynolds <mreynolds@redhat.com>
Date: Aug 06 2018 17:53:34 +0000
Subject: Ticket 49866 - Add password policy features to CLI/UI


Description:  Add global and local password policy functionality to
              dsconf and UI.

https://pagure.io/389-ds-base/issue/49866

Reviewed by: ?

---

diff --git a/ldap/schema/02common.ldif b/ldap/schema/02common.ldif
index 8efaf19..62e77a7 100644
--- a/ldap/schema/02common.ldif
+++ b/ldap/schema/02common.ldif
@@ -74,8 +74,8 @@ attributeTypes: ( 2.16.840.1.113730.3.1.2347 NAME ( 'passwordMaxSeqSets' 'pwdMax
 attributeTypes: ( 2.16.840.1.113730.3.1.2348 NAME ( 'passwordMaxClassChars' 'pwdMaxClassChars' ) DESC '389 Directory Server password policy attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 SINGLE-VALUE X-ORIGIN '389 Directory Server' )
 attributeTypes: ( 2.16.840.1.113730.3.1.2349 NAME ( 'passwordDictCheck' 'pwdDictCheck' ) DESC '389 Directory Server password policy attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 SINGLE-VALUE X-ORIGIN '389 Directory Server' )
 attributeTypes: ( 2.16.840.1.113730.3.1.2350 NAME ( 'passwordDictPath' 'pwdDictPath' ) DESC '389 Directory Server password policy attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 SINGLE-VALUE X-ORIGIN '389 Directory Server' )
-attributeTypes: ( 2.16.840.1.113730.3.1.2351 NAME ( 'passwordUserAttributes' 'pwdUserAttributes' ) DESC '389 Directory Server password policy attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 SINGLE-VALUE X-ORIGIN '389 Directory Server' )
-attributeTypes: ( 2.16.840.1.113730.3.1.2352 NAME ( 'passwordBadWords' 'pwdBadWords' ) DESC '389 Directory Server password policy attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 SINGLE-VALUE X-ORIGIN '389 Directory Server' )
+attributeTypes: ( 2.16.840.1.113730.3.1.2351 NAME ( 'passwordUserAttributes' 'pwdUserAttributes' ) DESC '389 Directory Server password policy attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE X-ORIGIN '389 Directory Server' )
+attributeTypes: ( 2.16.840.1.113730.3.1.2352 NAME ( 'passwordBadWords' 'pwdBadWords' ) DESC '389 Directory Server password policy attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE X-ORIGIN '389 Directory Server' )
 attributeTypes: ( 2.16.840.1.113730.3.1.198 NAME 'memberURL' DESC 'Netscape defined attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 X-ORIGIN 'Netscape Directory Server' )
 attributeTypes: ( 2.16.840.1.113730.3.1.199 NAME 'memberCertificateDescription' DESC 'Netscape defined attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 X-ORIGIN 'Netscape Directory Server' )
 attributeTypes: ( 2.16.840.1.113730.3.1.207 NAME 'vlvBase' DESC 'Netscape defined attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.12 X-ORIGIN 'Netscape Directory Server' )
@@ -149,7 +149,7 @@ objectClasses: ( 2.16.840.1.113730.3.2.7 NAME 'nsLicenseUser' DESC 'Netscape def
 objectClasses: ( 2.16.840.1.113730.3.2.1 NAME 'changeLogEntry' DESC 'LDAP changelog objectclass' SUP top MUST ( targetdn $ changeTime $ changenumber $ changeType ) MAY ( changes $ newrdn $ deleteoldrdn $ newsuperior ) X-ORIGIN 'Changelog Internet Draft' )
 objectClasses: ( 2.16.840.1.113730.3.2.6 NAME 'referral' DESC 'LDAP referrals objectclass' SUP top MAY ( ref ) X-ORIGIN 'LDAPv3 referrals Internet Draft' )
 objectClasses: ( 2.16.840.1.113730.3.2.12 NAME 'passwordObject' DESC 'Netscape defined password policy objectclass' SUP top MAY ( pwdpolicysubentry $ passwordExpirationTime $ passwordExpWarned $ passwordRetryCount $ retryCountResetTime $ accountUnlockTime $ passwordHistory $ passwordAllowChangeTime $ passwordGraceUserTime ) X-ORIGIN 'Netscape Directory Server' )
-objectClasses: ( 2.16.840.1.113730.3.2.13 NAME 'passwordPolicy' DESC 'Netscape defined password policy objectclass' SUP top MAY ( passwordMaxAge $ passwordExp $ passwordMinLength $ passwordKeepHistory $ passwordInHistory $ passwordChange $ passwordWarning $ passwordLockout $ passwordMaxFailure $ passwordResetDuration $ passwordUnlock $ passwordLockoutDuration $ passwordCheckSyntax $ passwordMustChange $ passwordStorageScheme $ passwordMinAge $ passwordResetFailureCount $ passwordGraceLimit $ passwordMinDigits $ passwordMinAlphas $ passwordMinUppers $ passwordMinLowers $ passwordMinSpecials $ passwordMin8bit $ passwordMaxRepeats $ passwordMinCategories $ passwordMinTokenLength $ passwordTrackUpdateTime $ passwordAdminDN ) X-ORIGIN 'Netscape Directory Server' )
+objectClasses: ( 2.16.840.1.113730.3.2.13 NAME 'passwordPolicy' DESC 'Netscape defined password policy objectclass' SUP top MAY ( passwordMaxAge $ passwordExp $ passwordMinLength $ passwordKeepHistory $ passwordInHistory $ passwordChange $ passwordWarning $ passwordLockout $ passwordMaxFailure $ passwordResetDuration $ passwordUnlock $ passwordLockoutDuration $ passwordCheckSyntax $ passwordMustChange $ passwordStorageScheme $ passwordMinAge $ passwordResetFailureCount $ passwordGraceLimit $ passwordMinDigits $ passwordMinAlphas $ passwordMinUppers $ passwordMinLowers $ passwordMinSpecials $ passwordMin8bit $ passwordMaxRepeats $ passwordMinCategories $ passwordMinTokenLength $ passwordTrackUpdateTime $ passwordAdminDN $ passwordDictCheck $ passwordDictPath $ passwordPalindrome $ passwordMaxSequence $ passwordMaxClassChars $ passwordMaxSeqSets $ passwordBadWords $ passwordUserAttributes $ passwordSendExpiringTime ) X-ORIGIN 'Netscape Directory Server' )
 objectClasses: ( 2.16.840.1.113730.3.2.30 NAME 'glue' DESC 'Netscape defined objectclass' SUP top X-ORIGIN 'Netscape Directory Server' )
 objectClasses: ( 2.16.840.1.113730.3.2.32 NAME 'netscapeMachineData' DESC 'Netscape defined objectclass' SUP top X-ORIGIN 'Netscape Directory Server' )
 objectClasses: ( 2.16.840.1.113730.3.2.38 NAME 'vlvSearch' DESC 'Netscape defined objectclass' SUP top MUST ( cn $ vlvBase $ vlvScope $ vlvFilter ) MAY ( multiLineDescription ) X-ORIGIN 'Netscape Directory Server' )
diff --git a/ldap/servers/slapd/add.c b/ldap/servers/slapd/add.c
index 8f2fdea..9b53f15 100644
--- a/ldap/servers/slapd/add.c
+++ b/ldap/servers/slapd/add.c
@@ -150,7 +150,7 @@ do_add(Slapi_PBlock *pb)
         }
 
         if (vals == NULL) {
-            slapi_log_err(SLAPI_LOG_ERR, "do_add - no values for type %s\n", type, 0, 0);
+            slapi_log_err(SLAPI_LOG_ERR, "do_add", "no values for type %s\n", type);
             op_shared_log_error_access(pb, "ADD", slapi_sdn_get_dn(slapi_entry_get_sdn_const(e)), "null value");
             send_ldap_result(pb, LDAP_PROTOCOL_ERROR, NULL, NULL,
                              0, NULL);
diff --git a/ldap/servers/slapd/pw.c b/ldap/servers/slapd/pw.c
index 38d9e06..186657d 100644
--- a/ldap/servers/slapd/pw.c
+++ b/ldap/servers/slapd/pw.c
@@ -2096,6 +2096,11 @@ new_passwdPolicy(Slapi_PBlock *pb, const char *dn)
                                           slapi_value_get_string(*sval));
                         }
                     }
+                } else if (!strcasecmp(attr_name, "passwordsendexpiringtime")) {
+                    if ((sval = attr_get_present_values(attr))) {
+                        pwdpolicy->pw_send_expiring =
+                            pw_boolean_str2value(slapi_value_get_string(*sval));
+                    }
                 } else if (!strcasecmp(attr_name, "passwordhistory")) {
                     if ((sval = attr_get_present_values(attr))) {
                         pwdpolicy->pw_history =
diff --git a/src/cockpit/389-console/js/backend.js b/src/cockpit/389-console/js/backend.js
index 2c5a3fd..46da289 100644
--- a/src/cockpit/389-console/js/backend.js
+++ b/src/cockpit/389-console/js/backend.js
@@ -156,8 +156,6 @@ function load_jstree() {
     var node_type = data.selected[0];
     var suffix = data.instance.get_node(data.selected[0]).text.replace(/(\r\n|\n|\r)/gm,"");
 
-    console.log("The selected nodes are: " + node_type + " = " + suffix);
-
     if (node_type.startsWith("dblink")) {
       var parent_suffix = node_type.substring(node_type.indexOf('-')+1);
       $(".all-pages").hide();
@@ -857,6 +855,8 @@ $(document).ready( function() {
       });
     });
 
+    // Page is loaded, mark it as so...
+    db_page_loaded = 1;
   });
 });
 
diff --git a/src/cockpit/389-console/js/ds.js b/src/cockpit/389-console/js/ds.js
index 540a294..f86b8e9 100644
--- a/src/cockpit/389-console/js/ds.js
+++ b/src/cockpit/389-console/js/ds.js
@@ -2,8 +2,23 @@ var DS_HOME = "/etc/dirsrv/";
 var server_id = "None";
 var server_inst = "";
 var dn_regex = new RegExp( "^([A-Za-z]+=.*)" );
+
+/*
+ * We can't load the config until all the html pages are load, so we'll use vars
+ * to track the loading, and once all the pages are loaded, then we can load the config
+ */
+var server_page_loaded = 0;
+var security_page_loaded = 0;
+var db_page_loaded = 0;
+var repl_page_loaded = 0;
+var plugin_page_loaded = 0;
+var schema_page_loaded = 0;
+var monitor_page_loaded = 0;
+
+// objects to store original values (used for comparing what changed when saving
 var config_values = {};
-//TODO - need "config_values" for all the other pages: SASL, backend, suffix, etc.
+var localpwp_values = {};
+//TODO - need "config_values" for all the other pages: backend, replication, suffix, etc.
 
 var DSCONF = "dsconf";
 var DSCTL = "dsctl";
@@ -39,17 +54,6 @@ function tableize (val) {
   return val;
 }
 
-// Example
-function search_dse(){
-  document.getElementById('results').innerHTML = "Searching root dse...";
-  var cmd = ['/usr/bin/ldapsearch','-Y', 'EXTERNAL' , '-H',
-             'ldapi://%2fvar%2frun%2fslapd-localhost.socket',
-             '-b' ,'' ,'-s', 'base', 'objectclass=top'];
-  cockpit.spawn(cmd, { superuser: true }).done(function(data) {
-    $("#results").text(data); }
-  );
-}
-
 /*
  * Set the ports numbers on the instance creation form.  If the default ports
  * are taken just unset the values.
@@ -77,11 +81,6 @@ function sort_list (sel) {
   sel.html('').append(opts_list);
 }
 
-function example() {
-  // Example test function
-  $("#search").on("click", search_dse);
-  //$("#getservers").on("click", get_insts);
-}
 
 function set_no_insts () {
     var select = document.getElementById("select-server");
@@ -121,7 +120,6 @@ function check_inst_alive (connect_err) {
       $("#ds-navigation").hide();
       $(".all-pages").hide();
       $("#no-connect").show();
-
     } else {
       $(".all-pages").hide();
       $("#ds-navigation").show();
@@ -131,13 +129,11 @@ function check_inst_alive (connect_err) {
       //$("#no-package").hide();
       $("#not-running").hide();
       $("#no_connect").hide();
-      console.log("Running");
     }
   }).fail(function(data) {
     $("#ds-navigation").hide();
     $(".all-pages").hide();
     $("#not-running").show();
-    console.log("Not Running");
   });
 }
 
@@ -170,7 +166,6 @@ function get_insts() {
 
     // Update the list
     for (i = 0; i < insts.length; i++) {
-      console.log("Add instance: " + insts[i]);
       var opt = insts[i];
       var el = document.createElement("option");
       el.textContent = opt;
@@ -190,9 +185,10 @@ function get_insts() {
       $("#server-config").show();
       server_id = insts[0];
       server_inst = insts[0].replace("slapd-", "");
+      check_inst_alive();
+      // We have an instance, so load its config
       load_config();
     }
-
     $("body").show();
   }).fail(function(error){
     set_no_insts();
@@ -259,18 +255,27 @@ function save_all () {
   //   save_chaining_suffix();
   //   save_global_backend();
   //   save_suffix();
-  //   save_sasl();
   //   save_security();
 }
 
 function load_config (){
-  // TODO - set all the pages
+  // Populate all the suffix dropdown lists
+  update_suffix_dropdowns();
+
+  // Server page
   get_and_set_config(); // cn=config stuff
-  get_and_set_sasl();  // Fill in sasl mapping table
+  get_and_set_sasl();
+  get_and_set_localpwp();
+
+  // Security page
+  // Database page
+  // Replication page
+  // Schema page
+  // Plugin page
+  // Monitoring page
 }
 
 $(window.document).ready(function() {
-
   if(navigator.userAgent.toLowerCase().indexOf('firefoxf') > -1) {
     $("select@@@").focus( function() {
       this.style.setProperty( 'outline', 'none', 'important' );
@@ -279,3 +284,5 @@ $(window.document).ready(function() {
     });
   }
 });
+
+
diff --git a/src/cockpit/389-console/js/monitor.js b/src/cockpit/389-console/js/monitor.js
index 3ed2ad8..355c59b 100644
--- a/src/cockpit/389-console/js/monitor.js
+++ b/src/cockpit/389-console/js/monitor.js
@@ -153,7 +153,6 @@ function refresh_errors_log () {
 
 $(document).ready( function() {
   $("#monitor-content").load("monitor.html", function () {
-
     $('#monitor-db-tree').jstree({
       "plugins": [ "contextmenu", "wholerow" ],
     });
@@ -233,8 +232,6 @@ $(document).ready( function() {
     });
 
     $('#monitor-db-tree').on("changed.jstree", function (e, data) {
-      console.log("MONITOR The selected nodes are:");
-      console.log(data.selected);
       var tree_node = data.selected;
       if (tree_node == "monitor-db-main") {
 
@@ -394,6 +391,7 @@ $(document).ready( function() {
       $("#monitor-winsync-agmt-form").css('display', 'block');
     });
 
-
+    // Page is loaded, mark it as so...
+    monitor_page_loaded = 1;
   });
 });
diff --git a/src/cockpit/389-console/js/plugins.js b/src/cockpit/389-console/js/plugins.js
index 9c3f554..b34d04f 100644
--- a/src/cockpit/389-console/js/plugins.js
+++ b/src/cockpit/389-console/js/plugins.js
@@ -1,6 +1,5 @@
 $(document).ready( function() {
   $("#plugin-content").load("plugins.html", function () {
-
     $('#plugin-table').DataTable ( {
       "lengthMenu": [[10, 25, 50, -1], [10, 25, 50, "All"]],
       "bAutoWidth": false,
@@ -19,6 +18,7 @@ $(document).ready( function() {
       $(".all-pages").hide();
       $("#plugin-content").show();
     });
-
+    // Page is loaded, mark it as so...
+    plugin_page_loaded = 1;
   });
 });
diff --git a/src/cockpit/389-console/js/replication.js b/src/cockpit/389-console/js/replication.js
index ae817e6..182cf5f 100644
--- a/src/cockpit/389-console/js/replication.js
+++ b/src/cockpit/389-console/js/replication.js
@@ -117,7 +117,6 @@ function add_repl_mgr(dn){
 
 $(document).ready( function() {
   $("#replication-content").load("replication.html", function () {
-
     // Load the dropdown TODO
 
     binddn_list_color = $("#repl-managers-list").css("border-color");
@@ -775,6 +774,7 @@ $(document).ready( function() {
        // TODO - abort the cleantask - update table (remove or update existing clean task?)
     });
 
-
+    // Page is loaded, mark it as so...
+    repl_page_loaded = 1;
   });
 });
diff --git a/src/cockpit/389-console/js/schema.js b/src/cockpit/389-console/js/schema.js
index 6ae3a7f..13d2478 100644
--- a/src/cockpit/389-console/js/schema.js
+++ b/src/cockpit/389-console/js/schema.js
@@ -52,7 +52,6 @@ function clear_attr_form() {
 
 $(document).ready( function() {
   $("#schema-content").load("schema.html", function (){
-
     // TODO Get attributes, Objectclasses, syntaxes, and matching rules: populate tables and forms
 
     // Setup the tables: standard, custom, and Matching Rules
@@ -346,6 +345,8 @@ $(document).ready( function() {
         }
       });
     });
+    // Page is loaded, mark it as so...
+    schema_page_loaded = 1;
   });
 });
 
diff --git a/src/cockpit/389-console/js/security.js b/src/cockpit/389-console/js/security.js
index 324c170..fd76dbb 100644
--- a/src/cockpit/389-console/js/security.js
+++ b/src/cockpit/389-console/js/security.js
@@ -130,7 +130,8 @@ $(document).ready( function() {
         "orderable": false
       } ]
     });
-
+    // Page is loaded, mark it as so...
+    security_page_loaded = 1;
   });
 });
 
